#
# NDK build file
#
# Written by Ant-ON
#
# Copyright(c) 2011-2022
#

#
# Based on 7zip 21.03:
# https://7-zip.org/a/7z2103-src.7z
#

LOCAL_PATH := $(call my-dir)
include $(CLEAR_VARS)

LOCAL_MODULE := libp7zip

LOCAL_C_INCLUDES := $(LOCAL_PATH) \
	$(LOCAL_PATH)/ZAUI/ \
	$(LOCAL_PATH)/ZAIO/ \
	$(LOCAL_PATH)/CPP/ \
	$(LOCAL_PATH)/CPP/Common/ \
	$(LOCAL_PATH)/CPP/Windows/ \
	$(LOCAL_PATH)/CPP/7zip/ \
	$(LOCAL_PATH)/CPP/7zip/Archive/ \
	$(LOCAL_PATH)/CPP/7zip/Archive/Common/ \
	$(LOCAL_PATH)/CPP/7zip/Archive/7z/ \
	$(LOCAL_PATH)/CPP/7zip/Archive/Chm/ \
	$(LOCAL_PATH)/CPP/7zip/Archive/Com/ \
	$(LOCAL_PATH)/CPP/7zip/Archive/Cab/ \
	$(LOCAL_PATH)/CPP/7zip/Archive/Hfs/ \
	$(LOCAL_PATH)/CPP/7zip/Archive/Iso/ \
	$(LOCAL_PATH)/CPP/7zip/Archive/Nsis/ \
	$(LOCAL_PATH)/CPP/7zip/Archive/Rar/ \
	$(LOCAL_PATH)/CPP/7zip/Archive/Tar/ \
	$(LOCAL_PATH)/CPP/7zip/Archive/Udf/ \
	$(LOCAL_PATH)/CPP/7zip/Archive/Wim/ \
	$(LOCAL_PATH)/CPP/7zip/Archive/Zip/ \
	$(LOCAL_PATH)/CPP/7zip/Compress/ \
	$(LOCAL_PATH)/CPP/7zip/Crypto/ \
	$(LOCAL_PATH)/CPP/7zip/UI/ \
	$(LOCAL_PATH)/C/ \
	$(LOCAL_PATH)/C/lz4 \
	$(LOCAL_PATH)/C/lz5 \
	$(LOCAL_PATH)/C/mt/ \
	$(LOCAL_PATH)/C/zstd/ \
	$(LOCAL_PATH)/../include/ \
	android/cpufeatures \

P7ZIP_SRC=\
  CPP/7zip/Archive/Common/CoderMixer2.cpp \
  CPP/7zip/Archive/Common/DummyOutStream.cpp \
  CPP/7zip/Archive/Common/FindSignature.cpp \
  CPP/7zip/Archive/Common/HandlerOut.cpp \
  CPP/7zip/Archive/Common/InStreamWithCRC.cpp \
  CPP/7zip/Archive/Common/ItemNameUtils.cpp \
  CPP/7zip/Archive/Common/MultiStream.cpp \
  CPP/7zip/Archive/Common/OutStreamWithCRC.cpp \
  CPP/7zip/Archive/Common/OutStreamWithSha1.cpp \
  CPP/7zip/Archive/Common/ParseProperties.cpp \
  \
  CPP/7zip/Archive/7z/7zCompressionMode.cpp \
  CPP/7zip/Archive/7z/7zDecode.cpp \
  CPP/7zip/Archive/7z/7zEncode.cpp \
  CPP/7zip/Archive/7z/7zExtract.cpp \
  CPP/7zip/Archive/7z/7zFolderInStream.cpp \
  CPP/7zip/Archive/7z/7zHandler.cpp \
  CPP/7zip/Archive/7z/7zHandlerOut.cpp \
  CPP/7zip/Archive/7z/7zHeader.cpp \
  CPP/7zip/Archive/7z/7zIn.cpp \
  CPP/7zip/Archive/7z/7zOut.cpp \
  CPP/7zip/Archive/7z/7zProperties.cpp \
  CPP/7zip/Archive/7z/7zRegister.cpp \
  CPP/7zip/Archive/7z/7zSpecStream.cpp \
  CPP/7zip/Archive/7z/7zUpdate.cpp \
  \
  CPP/7zip/Archive/Cab/CabBlockInStream.cpp \
  CPP/7zip/Archive/Cab/CabHandler.cpp \
  CPP/7zip/Archive/Cab/CabHeader.cpp \
  CPP/7zip/Archive/Cab/CabIn.cpp \
  CPP/7zip/Archive/Cab/CabRegister.cpp \
  \
  CPP/7zip/Archive/Tar/TarHandler.cpp \
  CPP/7zip/Archive/Tar/TarHandlerOut.cpp \
  CPP/7zip/Archive/Tar/TarHeader.cpp \
  CPP/7zip/Archive/Tar/TarIn.cpp \
  CPP/7zip/Archive/Tar/TarOut.cpp \
  CPP/7zip/Archive/Tar/TarRegister.cpp \
  CPP/7zip/Archive/Tar/TarUpdate.cpp \
  \
  CPP/7zip/Archive/Zip/ZipAddCommon.cpp \
  CPP/7zip/Archive/Zip/ZipHandler.cpp \
  CPP/7zip/Archive/Zip/ZipHandlerOut.cpp \
  CPP/7zip/Archive/Zip/ZipIn.cpp \
  CPP/7zip/Archive/Zip/ZipItem.cpp \
  CPP/7zip/Archive/Zip/ZipOut.cpp \
  CPP/7zip/Archive/Zip/ZipRegister.cpp \
  CPP/7zip/Archive/Zip/ZipUpdate.cpp \
  \
  CPP/7zip/Archive/Rar/Rar5Handler.cpp \
  CPP/7zip/Archive/Rar/RarHandler.cpp \
  \
  CPP/7zip/Archive/Chm/ChmHandler.cpp \
  CPP/7zip/Archive/Chm/ChmIn.cpp \
  \
  CPP/7zip/Archive/Iso/IsoHandler.cpp \
  CPP/7zip/Archive/Iso/IsoHeader.cpp \
  CPP/7zip/Archive/Iso/IsoIn.cpp \
  CPP/7zip/Archive/Iso/IsoRegister.cpp \
  \
  CPP/7zip/Archive/Nsis/NsisDecode.cpp \
  CPP/7zip/Archive/Nsis/NsisHandler.cpp \
  CPP/7zip/Archive/Nsis/NsisIn.cpp \
  CPP/7zip/Archive/Nsis/NsisRegister.cpp \
  \
  CPP/7zip/Archive/Udf/UdfHandler.cpp \
  CPP/7zip/Archive/Udf/UdfIn.cpp \
  \
  CPP/7zip/Archive/Wim/WimHandler.cpp \
  CPP/7zip/Archive/Wim/WimHandlerOut.cpp \
  CPP/7zip/Archive/Wim/WimIn.cpp \
  CPP/7zip/Archive/Wim/WimRegister.cpp \
  \
  CPP/7zip/Archive/ApmHandler.cpp \
  CPP/7zip/Archive/ArHandler.cpp \
  CPP/7zip/Archive/ArjHandler.cpp \
  CPP/7zip/Archive/Base64Handler.cpp \
  CPP/7zip/Archive/Bz2Handler.cpp \
  CPP/7zip/Archive/ComHandler.cpp \
  CPP/7zip/Archive/CramfsHandler.cpp \
  CPP/7zip/Archive/CpioHandler.cpp \
  CPP/7zip/Archive/DeflateProps.cpp \
  CPP/7zip/Archive/DmgHandler.cpp \
  CPP/7zip/Archive/EcmHandler.cpp \
  CPP/7zip/Archive/ElfHandler.cpp \
  CPP/7zip/Archive/ExtHandler.cpp \
  CPP/7zip/Archive/FatHandler.cpp \
  CPP/7zip/Archive/FlvHandler.cpp \
  CPP/7zip/Archive/GptHandler.cpp \
  CPP/7zip/Archive/GzHandler.cpp \
  CPP/7zip/Archive/HfsHandler.cpp \
  CPP/7zip/Archive/LzHandler.cpp \
  CPP/7zip/Archive/LzhHandler.cpp \
  CPP/7zip/Archive/LzmaHandler.cpp \
  CPP/7zip/Archive/MachoHandler.cpp \
  CPP/7zip/Archive/MbrHandler.cpp \
  CPP/7zip/Archive/MslzHandler.cpp \
  CPP/7zip/Archive/MubHandler.cpp \
  CPP/7zip/Archive/NtfsHandler.cpp \
  CPP/7zip/Archive/PeHandler.cpp \
  CPP/7zip/Archive/PpmdHandler.cpp \
  CPP/7zip/Archive/QcowHandler.cpp \
  CPP/7zip/Archive/RpmHandler.cpp \
  CPP/7zip/Archive/SplitHandler.cpp \
  CPP/7zip/Archive/SquashfsHandler.cpp \
  CPP/7zip/Archive/SwfHandler.cpp \
  CPP/7zip/Archive/UefiHandler.cpp \
  CPP/7zip/Archive/VdiHandler.cpp \
  CPP/7zip/Archive/VhdHandler.cpp \
  CPP/7zip/Archive/VmdkHandler.cpp \
  CPP/7zip/Archive/XarHandler.cpp \
  CPP/7zip/Archive/XzHandler.cpp \
  CPP/7zip/Archive/ZHandler.cpp \
  CPP/7zip/Archive/HandlerCont.cpp \
  CPP/7zip/Archive/ZstdHandler.cpp \
  \
  CPP/7zip/Common/CWrappers.cpp \
  CPP/7zip/Common/CreateCoder.cpp \
  CPP/7zip/Common/FilterCoder.cpp \
  CPP/7zip/Common/InBuffer.cpp \
  CPP/7zip/Common/LimitedStreams.cpp \
  CPP/7zip/Common/MemBlocks.cpp \
  CPP/7zip/Common/MethodId.cpp \
  CPP/7zip/Common/MethodProps.cpp \
  CPP/7zip/Common/OffsetStream.cpp \
  CPP/7zip/Common/OutBuffer.cpp \
  CPP/7zip/Common/OutMemStream.cpp \
  CPP/7zip/Common/ProgressMt.cpp \
  CPP/7zip/Common/ProgressUtils.cpp \
  CPP/7zip/Common/PropId.cpp \
  CPP/7zip/Common/StreamBinder.cpp \
  CPP/7zip/Common/StreamObjects.cpp \
  CPP/7zip/Common/StreamUtils.cpp \
  CPP/7zip/Common/UniqBlocks.cpp \
  CPP/7zip/Common/VirtThread.cpp \
  \
  CPP/7zip/Compress/BZip2Crc.cpp \
  CPP/7zip/Compress/BZip2Decoder.cpp \
  CPP/7zip/Compress/BZip2Encoder.cpp \
  CPP/7zip/Compress/BZip2Register.cpp \
  CPP/7zip/Compress/Bcj2Coder.cpp \
  CPP/7zip/Compress/Bcj2Register.cpp \
  CPP/7zip/Compress/BcjCoder.cpp \
  CPP/7zip/Compress/BcjRegister.cpp \
  CPP/7zip/Compress/BitlDecoder.cpp \
  CPP/7zip/Compress/BranchMisc.cpp \
  CPP/7zip/Compress/BranchRegister.cpp \
  CPP/7zip/Compress/ByteSwap.cpp \
  CPP/7zip/Compress/CopyCoder.cpp \
  CPP/7zip/Compress/CopyRegister.cpp \
  CPP/7zip/Compress/Deflate64Register.cpp \
  CPP/7zip/Compress/DeflateDecoder.cpp \
  CPP/7zip/Compress/DeflateEncoder.cpp \
  CPP/7zip/Compress/DeflateRegister.cpp \
  CPP/7zip/Compress/DeltaFilter.cpp \
  CPP/7zip/Compress/EcmDecoder.cpp \
  CPP/7zip/Compress/ImplodeDecoder.cpp \
  CPP/7zip/Compress/ImplodeHuffmanDecoder.cpp \
  CPP/7zip/Compress/LzOutWindow.cpp \
  CPP/7zip/Compress/Lzma2Decoder.cpp \
  CPP/7zip/Compress/Lzma2Encoder.cpp \
  CPP/7zip/Compress/Lzma2Register.cpp \
  CPP/7zip/Compress/LzmaDecoder.cpp \
  CPP/7zip/Compress/LzmaEncoder.cpp \
  CPP/7zip/Compress/LzmaRegister.cpp \
  CPP/7zip/Compress/LzmsDecoder.cpp \
  CPP/7zip/Compress/LzhDecoder.cpp \
  CPP/7zip/Compress/LzxDecoder.cpp \
  CPP/7zip/Compress/PpmdDecoder.cpp \
  CPP/7zip/Compress/PpmdEncoder.cpp \
  CPP/7zip/Compress/PpmdRegister.cpp \
  CPP/7zip/Compress/PpmdZip.cpp \
  CPP/7zip/Compress/QuantumDecoder.cpp \
  CPP/7zip/Compress/Rar1Decoder.cpp \
  CPP/7zip/Compress/Rar2Decoder.cpp \
  CPP/7zip/Compress/Rar3Decoder.cpp \
  CPP/7zip/Compress/Rar3Vm.cpp \
  CPP/7zip/Compress/Rar5Decoder.cpp \
  CPP/7zip/Compress/RarCodecsRegister.cpp \
  CPP/7zip/Compress/ShrinkDecoder.cpp \
  CPP/7zip/Compress/XpressDecoder.cpp \
  CPP/7zip/Compress/ZDecoder.cpp \
  CPP/7zip/Compress/ZlibEncoder.cpp \
  CPP/7zip/Compress/ZlibDecoder.cpp \
  CPP/7zip/Compress/XzEncoder.cpp \
  CPP/7zip/Compress/XzDecoder.cpp \
  CPP/7zip/Compress/LzfseDecoder.cpp \
  CPP/7zip/Compress/ZstdDecoder.cpp \
  CPP/7zip/Compress/ZstdEncoder.cpp \
  CPP/7zip/Compress/ZstdRegister.cpp \
  CPP/7zip/Compress/FastLzma2Encoder.cpp \
  CPP/7zip/Compress/FastLzma2Register.cpp \
  \
  CPP/7zip/Crypto/7zAes.cpp \
  CPP/7zip/Crypto/7zAesRegister.cpp \
  CPP/7zip/Crypto/HmacSha1.cpp \
  CPP/7zip/Crypto/HmacSha256.cpp \
  CPP/7zip/Crypto/MyAes.cpp \
  CPP/7zip/Crypto/MyAesReg.cpp \
  CPP/7zip/Crypto/Pbkdf2HmacSha1.cpp \
  CPP/7zip/Crypto/RandGen.cpp \
  CPP/7zip/Crypto/Rar5Aes.cpp \
  CPP/7zip/Crypto/Rar20Crypto.cpp \
  CPP/7zip/Crypto/RarAes.cpp \
  CPP/7zip/Crypto/WzAes.cpp \
  CPP/7zip/Crypto/ZipCrypto.cpp \
  CPP/7zip/Crypto/ZipStrong.cpp \
  \
  CPP/7zip/UI/Common/ArchiveCommandLine.cpp \
  CPP/7zip/UI/Common/ArchiveExtractCallback.cpp \
  CPP/7zip/UI/Common/ArchiveOpenCallback.cpp \
  CPP/7zip/UI/Common/DefaultName.cpp \
  CPP/7zip/UI/Common/EnumDirItems.cpp \
  CPP/7zip/UI/Common/Extract.cpp \
  CPP/7zip/UI/Common/ExtractingFilePath.cpp \
  CPP/7zip/UI/Common/LoadCodecs.cpp \
  CPP/7zip/UI/Common/OpenArchive.cpp \
  CPP/7zip/UI/Common/PropIDUtils.cpp \
  CPP/7zip/UI/Common/SetProperties.cpp \
  CPP/7zip/UI/Common/SortUtils.cpp \
  CPP/7zip/UI/Common/TempFiles.cpp \
  CPP/7zip/UI/Common/Update.cpp \
  CPP/7zip/UI/Common/UpdateAction.cpp \
  CPP/7zip/UI/Common/UpdateCallback.cpp \
  CPP/7zip/UI/Common/UpdatePair.cpp \
  CPP/7zip/UI/Common/UpdateProduce.cpp \
  \
  CPP/Common/CRC.cpp \
  CPP/Common/CommandLineParser.cpp \
  CPP/Common/CrcReg.cpp \
  CPP/Common/IntToString.cpp \
  CPP/Common/MyString.cpp \
  CPP/Common/MyXml.cpp \
  CPP/Common/MyMap.cpp \
  CPP/Common/MyVector.cpp \
  CPP/Common/MyWindows.cpp \
  CPP/Common/Sha1Prepare.cpp \
  CPP/Common/Sha1Reg.cpp \
  CPP/Common/Sha256Prepare.cpp \
  CPP/Common/Sha256Reg.cpp \
  CPP/Common/StringToInt.cpp \
  CPP/Common/UTFConvert.cpp \
  CPP/Common/Wildcard.cpp \
  CPP/Common/XzCrc64Reg.cpp \
  CPP/Common/XzCrc64Init.cpp \
  CPP/Common/LzFindPrepare.cpp \
  \
  CPP/Windows/ErrorMsg.cpp \
  CPP/Windows/FileLink.cpp \
  CPP/Windows/FileName.cpp \
  CPP/Windows/PropVariant.cpp \
  CPP/Windows/PropVariantConv.cpp \
  CPP/Windows/PropVariantUtils.cpp \
  CPP/Windows/Synchronization.cpp \
  CPP/Windows/System.cpp \
  CPP/Windows/TimeUtils.cpp \
  \
  C/7zCrc.c \
  C/7zCrcOpt.c \
  C/7zStream.c \
  C/Aes.c \
  C/AesOpt.c \
  C/Alloc.c \
  C/Bcj2.c \
  C/Bcj2Enc.c \
  C/Blake2s.c \
  C/Bra.c \
  C/Bra86.c \
  C/BraIA64.c \
  C/BwtSort.c \
  C/CpuArch.c \
  C/Delta.c \
  C/HuffEnc.c \
  C/LzFind.c \
  C/LzFindMt.c \
  C/LzFindOpt.c \
  C/Lzma2Dec.c \
  C/Lzma2Enc.c \
  C/LzmaDec.c \
  C/LzmaEnc.c \
  C/MtCoder.c \
  C/Ppmd7.c \
  C/Ppmd7aDec.c \
  C/Ppmd7Dec.c \
  C/Ppmd7Enc.c \
  C/Ppmd8.c \
  C/Ppmd8Dec.c \
  C/Ppmd8Enc.c \
  C/Sha1.c \
  C/Sha1Opt.c \
  C/Sha256.c \
  C/Sha256Opt.c \
  C/Sort.c \
  C/Threads.c \
  C/Xz.c \
  C/XzCrc64.c \
  C/XzCrc64Opt.c \
  C/XzDec.c \
  C/XzEnc.c \
  C/XzIn.c \
  C/Lzma2DecMt.c \
  C/MtDec.c \
  \
  C/lz4/lz4.c \
  C/lz4/lz4frame.c \
  C/lz4/lz4hc.c \
  C/lz4/xxhash.c \
  C/mt/lz4-mt_common.c \
  C/mt/lz4-mt_compress.c \
  C/mt/lz4-mt_decompress.c \
  C/mt/threading.c \
  CPP/7zip/Compress/Lz4Decoder.cpp \
  CPP/7zip/Compress/Lz4Encoder.cpp \
  CPP/7zip/Compress/Lz4Register.cpp \
  CPP/7zip/Archive/Lz4Handler.cpp \
  \
  C/zstd/debug.c \
  C/zstd/entropy_common.c \
  C/zstd/error_private.c \
  C/zstd/fse_compress.c \
  C/zstd/fse_decompress.c \
  C/zstd/hist.c \
  C/zstd/huf_compress.c \
  C/zstd/huf_decompress.c \
  C/zstd/pool.c \
  C/zstd/threading.c \
  C/zstd/zstd_common.c \
  C/zstd/zstd_compress.c \
  C/zstd/zstd_compress_literals.c \
  C/zstd/zstd_compress_sequences.c \
  C/zstd/zstd_compress_superblock.c \
  C/zstd/zstd_ddict.c \
  C/zstd/zstd_decompress_block.c \
  C/zstd/zstd_decompress.c \
  C/zstd/zstd_double_fast.c \
  C/zstd/zstd_fast.c \
  C/zstd/zstd_lazy.c \
  C/zstd/zstd_ldm.c \
  C/zstd/zstdmt_compress.c \
  C/zstd/zstd_opt.c \
  C/zstd/zstd_v01.c \
  C/zstd/zstd_v02.c \
  C/zstd/zstd_v03.c \
  C/zstd/zstd_v04.c \
  C/zstd/zstd_v05.c \
  C/zstd/zstd_v06.c \
  C/zstd/zstd_v07.c \
  \
  C/fast-lzma2/dict_buffer.c \
  C/fast-lzma2/fl2_common.c \
  C/fast-lzma2/fl2_compress.c \
  C/fast-lzma2/fl2_pool.c \
  C/fast-lzma2/fl2_threading.c \
  C/fast-lzma2/lzma2_enc.c \
  C/fast-lzma2/radix_bitpack.c \
  C/fast-lzma2/radix_mf.c \
  C/fast-lzma2/radix_struct.c \
  C/fast-lzma2/range_enc.c \
  \
#  C/lz5/lz5.c \
#  C/lz5/lz5frame.c \
#  C/lz5/lz5hc.c \
#  C/mt/lz5-mt_common.c \
#  C/mt/lz5-mt_compress.c \
#  C/mt/lz5-mt_decompress.c \
#  CPP/7zip/Compress/Lz5Decoder.cpp \
#  CPP/7zip/Compress/Lz5Encoder.cpp \
#  CPP/7zip/Compress/Lz5Register.cpp \
#  CPP/7zip/Archive/Lz5Handler.cpp \

LOCAL_SRC_FILES := $(P7ZIP_SRC) \
  \
  ZAUI/ExtractCallbackConsole.cpp \
  ZAUI/ExtractCallbackSilent.cpp \
  ZAUI/OpenCallbackConsole.cpp \
  ZAUI/UpdateCallbackConsole.cpp \
  ZAUI/List.cpp \
  ZAUI/Main.cpp \
  ZAUI/MainPipe.cpp \
  ZAUI/StringConvert.cpp \
  ZAUI/StringConvertOEM.cpp \
  \
  ZAIO/Common/FileStreams.cpp \
  ZAIO/Common/FilePathAutoRename.cpp \
  ZAIO/Common/InOutTempBuffer.cpp \
  ZAIO/Windows/FileDir.cpp \
  ZAIO/Windows/FileFind.cpp \
  ZAIO/Windows/FileIO.cpp \

# Exceptions support
LOCAL_CPP_FEATURES := exceptions
# Fix work exceptions
LOCAL_LDFLAGS +=-Wl,--exclude-libs,libgcc.a -Wl,--exclude-libs,libunwind.a

P7ZIP_MAIN_FLAGS := -DANDROID_NDK -D__ANDROID__ \
	-DENV_UNIX -DUNICODE -D_UNICODE -DUNIX_USE_WIN_FILE \
	-DANDROID_ZA -DANDROID_ZA_OEM \
	-DANDROID_FIX_SEEK_64 \
	-DANDROID_ZA_FAST_FULL_EXTRACT \
	-DANDROID_USE_UTIMENSET_SYSCALL \
	-DANDROID_IO_WRAPPER \
	-DANDROID_USE_MEMALIGN \
	\
	-DSUPPORT_LZFSE \
	-DNO_XXHASH \
	-DZSTD_LEGACY_SUPPORT -DZSTD_MULTITHREAD \
	-DLZ4_DISABLE_DEPRECATE_WARNINGS -D__COMMON_NEW_HANDLER_H \
	\
	-D_FILE_OFFSET_BITS=64 \
	\
	-DZSTDLIB_VISIBILITY="" -DZSTDERRORLIB_VISIBILITY="" \
	-DFL2LIB_VISIBILITY="" -DLZ4_LIB_VISIBILITY=""

# Use ASM for ARMV8 targets
ifeq ($(TARGET_ARCH_ABI),arm64-v8a)
P7ZIP_MAIN_FLAGS += -D_LZMA_DEC_OPT
LOCAL_SRC_FILES += Asm/arm64/LzmaDecOpt.S \
  Asm/arm64/7zAsm.S
endif

# Enable unaligned access for FL2, ZSTD, LZ5
ifeq ($(TARGET_ARCH_ABI),x86)
P7ZIP_MAIN_FLAGS += -DMEM_FORCE_MEMORY_ACCESS=2 -DXXH_FORCE_MEMORY_ACCESS=2
endif
ifeq ($(TARGET_ARCH_ABI),armeabi-v7a)
# https://fastcompression.blogspot.com/2015/08/accessing-unaligned-memory.html
# Don't use it for ARMv7 though: although it's compatible with unaligned load, 
# it can also issue multiple load instruction, which is a strict-align only opcode. 
# So the resulting binary would crash.
# ARMv7 does not support 64bit unaligned access.
P7ZIP_MAIN_FLAGS += -DMEM_FORCE_MEMORY_ACCESS=0 -DXXH_FORCE_MEMORY_ACCESS=0
endif
ifeq ($(TARGET_ARCH_ABI),arm64-v8a)
P7ZIP_MAIN_FLAGS += -DMEM_FORCE_MEMORY_ACCESS=2 -DXXH_FORCE_MEMORY_ACCESS=2
endif
ifeq ($(TARGET_ARCH_ABI),x86_64)
P7ZIP_MAIN_FLAGS += -DMEM_FORCE_MEMORY_ACCESS=2 -DXXH_FORCE_MEMORY_ACCESS=2
endif

P7ZIP_FLAGS := -DLOGTAG=\"7z\" $(P7ZIP_MAIN_FLAGS) -DANDROID_ZA_HW_OPT

OPTIMIZATION_FLAGS := -O2 \
	\
	-finline-functions -frename-registers \
	-fomit-frame-pointer -fno-strict-aliasing -funswitch-loops \
	-fgcse-after-reload \
	\
	-Wall -Wno-unknown-pragmas -Wno-unused-const-variable

LOCAL_CFLAGS := $(OPTIMIZATION_FLAGS) $(P7ZIP_FLAGS)
LOCAL_CPPFLAGS := $(OPTIMIZATION_FLAGS) $(P7ZIP_FLAGS) -fno-rtti
LOCAL_LDFLAGS += $(OPTIMIZATION_FLAGS)

# LTO increase library size and very long linking
DISABLE_LTO := 1

BUILD_TYPE := LIB
include $(LOCAL_PATH)/../BuildConfig.mk

LOCAL_SHARED_LIBRARIES := handler mime iconv
LOCAL_STATIC_LIBRARIES := cpufeatures hw nextension

LOCAL_LDLIBS := -llog

include $(BUILD_SHARED_LIBRARY)

$(call import-module,android/cpufeatures)
