/*
 * p7zip encoder for Error Code Modeler format
 * 
 * Author: Ant-ON <prozanton@gmail.com>
 * 
 * Based on ecm utility by Neill Corlett
 * 
 */

// EcmDecoder.h

#ifndef __COMPRESS_ECM_DECODER_H
#define __COMPRESS_ECM_DECODER_H

#include "../../Common/MyCom.h"

#include "../ICoder.h"

namespace NCompress 
{
namespace NEcm 
{

class CDecoder: public ICompressCoder, public CMyUnknownImp
{

	Byte ecc_f_lut[256];
	Byte ecc_b_lut[256];
	UInt32 edc_lut[256];

	Byte sector_buffer[2352];

public:
	CDecoder();
	~CDecoder() {};

	MY_UNKNOWN_IMP

	void put32(Byte * dest, const UInt32 value);
	UInt32 get32(const Byte *src);

	void eccedc_init();
	UInt32 edc_compute(UInt32 edc, const Byte *src, SizeT size);

	void ecc_writepq(const Byte* address, const Byte* data, SizeT major_count,
			SizeT minor_count, SizeT major_mult, SizeT minor_inc, Byte* ecc);
	void ecc_writesector(const Byte *address, const Byte *data, Byte *ecc);

	void reconstruct_sector(
			Byte* sector /*must point to a full 2352-byte sector*/, Byte type);

	HRESULT CodeReal(ISequentialInStream *inStream,
			ISequentialOutStream *outStream, const UInt64 *inSize,
			const UInt64 *outSize, ICompressProgressInfo *progress);

	STDMETHOD (Code)(ISequentialInStream *inStream,
			ISequentialOutStream *outStream, const UInt64 *inSize,
			const UInt64 *outSize, ICompressProgressInfo *progress);
};

}}

#endif
