// FilePathAutoRename.cpp

#include "StdAfx.h"

#include <Windows/FileFind.h>

#include <Common/FilePathAutoRename.h>

using namespace NWindows;

static bool MakeAutoName(const FString &name,
    const FString &extension, UInt32 value, FString &path)
{
  path = name;
  path.Add_UInt32(value);
  path += extension;
  return NFile::NFind::DoesFileOrDirExist(path);
}

bool AutoRenamePath(FString &path)
{
  int dotPos = path.ReverseFind_Dot();
  int slashPos = path.ReverseFind_PathSepar();

  FString name = path;
  FString extension;
  if (dotPos > slashPos + 1)
  {
    name.DeleteFrom((unsigned)dotPos);
    extension = path.Ptr((unsigned)dotPos);
  }
  name += '(';
  extension = ")" + extension;
  
  FString temp;

  for (unsigned i=1; i<100000; i++)
  {
    if (!MakeAutoName(name, extension, i, temp))
      return !MakeAutoName(name, extension, i, path);
  }

  return false;
}
