// InOutTempBuffer.h

#ifndef __IN_OUT_TEMP_BUFFER_H
#define __IN_OUT_TEMP_BUFFER_H

#include <Common/MyCom.h>
#include <Windows/FileDir.h>

#include <IStream.h>

class CInOutTempBuffer
{
  Byte *_buf;
  size_t _bufPos;
  UInt64 _size;
  UInt32 _crc;
  AString _path;
  int _fd;

  HRESULT WriteToFile(const void *data, UInt32 size);

  CLASS_NO_COPY(CInOutTempBuffer);
public:
  CInOutTempBuffer();
  ~CInOutTempBuffer();
  void Create();

  void InitWriting();
  HRESULT Write_HRESULT(const void *data, UInt32 size);
  HRESULT WriteToStream(ISequentialOutStream *stream);
  UInt64 GetDataSize() const { return _size; }
};

#endif
