// ExtractCallbackConsole.h

#ifndef __EXTRACT_CALLBACK_CONSOLE_H
#define __EXTRACT_CALLBACK_CONSOLE_H

#include <IPassword.h>
#include <Archive/IArchive.h>
#include <Common/ArchiveExtractCallback.h>
#ifndef _7ZIP_ST
#include <Windows/Synchronization.h>
#endif

#include "OpenCallbackConsole.h"

#include <time.h>

class CExtractScanConsole: public IDirItemsCallback
{
  int task_id;

public:
  void Init(int id)
  {
    task_id = id;
  }
  
  void SetWindowWidth(unsigned width) { }

  void StartScanning();
  
  INTERFACE_IDirItemsCallback(;)

  void CloseScanning();
  void PrintStat(const CDirItemsStat &st);
};




class CExtractCallbackConsole:
  public IExtractCallbackUI,
  // public IArchiveExtractCallbackMessage,
  public IFolderArchiveExtractCallback2,
  public ICryptoGetTextPassword,
  public COpenCallbackConsole,
  public CMyUnknownImp
{
public:
  MY_QUERYINTERFACE_BEGIN2(IFolderArchiveExtractCallback)
  // MY_QUERYINTERFACE_ENTRY(IArchiveExtractCallbackMessage)
  MY_QUERYINTERFACE_ENTRY(IFolderArchiveExtractCallback2)
  #ifndef _NO_CRYPTO
  MY_QUERYINTERFACE_ENTRY(ICryptoGetTextPassword)
  #endif
  MY_QUERYINTERFACE_END
  MY_ADDREF_RELEASE

  STDMETHOD(SetTotal)(UInt64 total);
  STDMETHOD(SetCompleted)(const UInt64 *completeValue);

  INTERFACE_IFolderArchiveExtractCallback(;)

  INTERFACE_IExtractCallbackUI(;)
  // INTERFACE_IArchiveExtractCallbackMessage(;)
  INTERFACE_IFolderArchiveExtractCallback2(;)

  STDMETHOD(CryptoGetTextPassword)(BSTR *password);
  
  UInt64 NumTryArcs;
  
  bool ThereIsError_in_Current;
  bool ThereIsWarning_in_Current;

  UInt64 NumOkArcs;
  UInt64 NumCantOpenArcs;
  UInt64 NumArcsWithError;
  UInt64 NumArcsWithWarnings;

  UInt64 NumOpenArcErrors;
  UInt64 NumOpenArcWarnings;
  
  UInt64 NumFileErrors;
  UInt64 NumFileErrors_in_Current;

  UInt64 size_next;
  UInt64 size_step;
  clock_t last_up;
  bool extracted;

  CExtractCallbackConsole()
      {}

  void SetWindowWidth(unsigned width) { }

  void Init(int id);
  
  NWindows::NSynchronization::CCriticalSection g_CriticalSection;
};

#endif
