// ExtractCallbackConsole.cpp

#include "StdAfx.h"

#include "ExtractCallbackSilent.h"

#include <Common/StringConvert.h>
#include <Windows/ErrorMsg.h>

#include "c2j_bridge.h"

using namespace NWindows;
using namespace NFile;

#define CheckBreak(task_id) \
	((jGetStatus(task_id) == STATUS_CANCEL)? E_ABORT : S_OK)

#ifndef _7ZIP_ST
#define MT_LOCK NSynchronization::CCriticalSectionLock lock(g_CriticalSection);
#else
#define MT_LOCK
#endif

STDMETHODIMP CExtractCallbackSilent::AskOverwrite(
    const wchar_t *existName, const FILETIME *existTime, const UInt64 *existSize,
    const wchar_t *newName, const FILETIME *newTime, const UInt64 *newSize,
    Int32 *answer)
{
	MT_LOCK

	*answer = NOverwriteAnswer::kNo;
	return CheckBreak(task_id);
}

STDMETHODIMP CExtractCallbackSilent::PrepareOperation(const wchar_t *name, Int32 /* isFolder */, Int32 askExtractMode, const UInt64 *position)
{
	MT_LOCK

	return CheckBreak(task_id);
}

#ifdef ANDROID_BIN
STDMETHODIMP CExtractCallbackSilent::MessageError(const wchar_t *message)
{
	MT_LOCK

	NumFileErrors_in_Current++;
	NumFileErrors++;

	return CheckBreak(task_id);
}

STDMETHODIMP CExtractCallbackSilent::SetOperationResult(const wchar_t *name, Int32 isExtract, Int32 opRes, Int32 encrypted)
{
	return S_OK;
}

HRESULT CExtractCallbackSilent::ExtractResult(HRESULT result)
{
	MT_LOCK

	if (result == S_OK)
	{
		if (NumFileErrors_in_Current == 0 && !ThereIsError_in_Current)
		{
		  if (ThereIsWarning_in_Current)
			NumArcsWithWarnings++;
		  else
			NumOkArcs++;
		}
		else
		  NumArcsWithError++;
	} else
	{
		NumArcsWithError++;
		if (result == E_ABORT)
			return result;
	}

	return CheckBreak(task_id);
}
#endif
