// OpenCallbackConsole.cpp

#include "StdAfx.h"

#include <stdlib.h>

#include "OpenCallbackConsole.h"

#include <Common/StringConvert.h>

#include <c2j_bridge.h>

HRESULT COpenCallbackConsole::Open_CheckBreak()
{
	return ((jGetStatus(task_id) == STATUS_CANCEL)? E_ABORT : S_OK);
}

HRESULT COpenCallbackConsole::Open_SetTotal(const UInt64 *files, const UInt64 *bytes)
{
	// TODO: open progress
	return Open_CheckBreak();
}

HRESULT COpenCallbackConsole::Open_SetCompleted(const UInt64 *files, const UInt64 *bytes)
{
	// TODO: open progress
	return Open_CheckBreak();
}

HRESULT COpenCallbackConsole::Open_Finished()
{
	return Open_CheckBreak();
}

HRESULT COpenCallbackConsole::Open_CryptoGetTextPassword(BSTR *password)
{
	PasswordWasAsked = true;
	RINOK(Open_CheckBreak());
	if (!PasswordIsDefined)
	{
		char *pwd = jGetPassword(task_id);
		if (pwd)
		{
			Password = MultiByteToUnicodeString(pwd, CP_UTF8);
			free(pwd);
			PasswordIsDefined = true;
		}
		RINOK(Open_CheckBreak());
	}
	
	return StringToBstr(Password, password);
}

bool COpenCallbackConsole::Open_WasPasswordAsked()
{
	return PasswordWasAsked;
}
