// UpdateCallbackConsole.h

#ifndef __UPDATE_CALLBACK_CONSOLE_H
#define __UPDATE_CALLBACK_CONSOLE_H

#include <Common/Update.h>

struct CErrorPathCodes
{
  FStringVector Paths;
  CRecordVector<DWORD> Codes;

  void AddError(const FString &path, DWORD systemError)
  {
    Paths.Add(path);
    Codes.Add(systemError);
  }
  void Clear()
  {
    Paths.Clear();
    Codes.Clear();
  }
};

class CCallbackConsoleBase
{
protected:
  void CommonError(const FString &path, DWORD systemError, bool isWarning);
  
  HRESULT ScanError_Base(const FString &path, DWORD systemError);
  HRESULT OpenFileError_Base(const FString &name, DWORD systemError);
  HRESULT ReadingFileError_Base(const FString &name, DWORD systemError);

public:
  CCallbackConsoleBase()
      {}
  
  void SetWindowWidth(unsigned width) { }

  void Init(int id)
  {
    FailedFiles.Clear();

    task_id = id;
  }

  CErrorPathCodes FailedFiles;
  CErrorPathCodes ScanErrors;
  
  int task_id;
};

class CUpdateCallbackConsole: public IUpdateCallbackUI2, public CCallbackConsoleBase
{
public:
  bool PasswordIsDefined;
  UString Password;
  bool AskPassword;

  CUpdateCallbackConsole()
      : PasswordIsDefined(false)
      , AskPassword(false)
      , size_total(0), size_curent(0)
      {}
  
  virtual ~CUpdateCallbackConsole() {};
  
  INTERFACE_IUpdateCallbackUI2(;)
  
  UInt64 size_total;
  int size_curent;
};

#endif
